generic-deriving-1.11.2: Generic programming library for generalised deriving.

Copyright | (c) 2012 University of Oxford
License | BSD3
Maintainer | generics@haskell.org
Stability | experimental
Portability | non-portable
Safe Haskell | Safe
Language | Haskell2010

Generics.Deriving.ConNames

Contents

- Functionality for retrieving the names of the possible contructors

Description

Summary: Return the name of all the constructors of a type.

Synopsis

- class ConNames f where
- conNames :: (Generic a, ConNames (Rep a)) => a -> [String]
- conNameOf :: (ConNames (Rep a), Generic a) => a -> String

# Functionality for retrieving the names of the possible contructors

class ConNames f where Source #

Minimal complete definition

gconNames, gconNameOf

Methods

gconNames :: f a -> [String] Source #

gconNameOf :: f a -> String Source #

Instances

(ConNames * f, ConNames * g) => ConNames * ((:+:) f g) Source # |
Methods gconNames :: f a -> [String] Source # gconNameOf :: f a -> String Source #
ConNames * f => ConNames * (D1 c f) Source # |
Methods gconNames :: f a -> [String] Source # gconNameOf :: f a -> String Source #
Constructor Meta c => ConNames * (C1 c f) Source # |
Methods gconNames :: f a -> [String] Source # gconNameOf :: f a -> String Source #

conNames :: (Generic a, ConNames (Rep a)) => a -> [String] Source #

Return the name of all the constructors of the type of the given term.

conNameOf :: (ConNames (Rep a), Generic a) => a -> String Source #

Return the name of the constructor of the given term